/* ***********************************************************
hi_files  Version 0.1.1
サイトマップ作成用　ファイルリスト作成ライブラリ

2014-03-23
hi_tag	http://studyhall.webcrow.jp/
*********************************************************** */
library hi_files;
import 'dart:io';

/**
 *  Get and keep File list
 *
 *  'option' is used for anything with other programs.
 *  type = 0:directory, 1:file
 */
class C_Files {
  var _dir;
  int filesCount;		// ファイル数
  int dirsCount;			// ディレクトリ数
  List<String> sTargetExt;	// 対象とする拡張子 (.は含まない)

  List<String> filename = new List();
  List<String> directory = new List();
  List<String> extension = new List();
  List<DateTime> timeStamp = new List();
  List<String> option = new List();		// from Ver.0.1.1
	List<int> type = new List();				// from Ver.0.1.1

  /**
   * sPath : Set target path
   * sTargetExt : Set target extensions (option)
   */
  C_Files(String path, [this.sTargetExt]) {
    _dir = new Directory(path);
  }

  /**
   * Get file list & parameters.
   *
   * nMode 1:Debug mode (print information)
   * return : files count.
   */
  int getSync([num mode]) {
  	filesCount = 0;
  	dirsCount = 0;
    FileSystemEntity currentFile;

    List<FileSystemEntity> files = _dir.listSync(recursive: true);

    files.forEach((currentFile) {
      if (currentFile is File) {
				if (mode == 1) print('Sync file ${currentFile.path}');
				// ファイル情報の取得
				String fullpath = currentFile.path;
		  	String sDir = fullpath.substring(0, fullpath.lastIndexOf('\\'));
      	String sFile = fullpath.substring(fullpath.lastIndexOf('\\') + 1);
      	String sExt = sFile.substring(sFile.lastIndexOf('.') + 1);
      	// 拡張子フィルター
      	bool chk = false;
      	if (sTargetExt != null) {
      		if (sTargetExt.indexOf(sExt) != -1) {
      			chk = true;
      		}
      	} else {
      		// 拡張子の指定がない時は全て対象
      		chk = true;
      	}
      	if (chk) {
    	  	directory.add(sDir);
    	  	filename.add(sFile);
        	extension.add(sExt);
  				timeStamp.add(currentFile.lastModifiedSync());
  				type.add(1);
  				filesCount += 1;
    		}
      } else if ((currentFile is Directory) && (sTargetExt == null)) {
      	// 拡張子の指定があるときはディレクトリは取得しない　(filename に null が入るため)
  	  	directory.add(currentFile.path);
  	  	filename.add(null);
      	extension.add(null);
				timeStamp.add(null);
				type.add(0);
        dirsCount += 1;
        if (mode == 1) print('Sync Dir ${currentFile.path}');
      }
    });
    return filesCount;
  }
}
class C_Dir {
  var _oDir;
  int nFilesCount;		// ファイル数
  int nDirsCount;			// ディレクトリ数
  List<String> sTargetExt;	// 対象とする拡張子 (.は含まない)

  List<String> sFileName = new List();
  List<String> sDirectory = new List();
  List<String> sExtension = new List();
  List<DateTime> oTimestamp = new List();

  /**
   * sPath : Set target path
   * sTargetExt : Set target extensions (option)
   */
  C_Dir(String sPath, [this.sTargetExt]) {
    _oDir = new Directory(sPath);
  }

  /**
   * Get file list & parameters.
   *
   * nMode 1:Debug mode (print information)
   * return : files count.
   */
  int getSync([num nMode]) {
  	nFilesCount = 0;
  	nDirsCount = 0;
    FileSystemEntity oFiles;

    List<FileSystemEntity> sFile = _oDir.listSync(recursive: true);

    sFile.forEach((oFiles) {
      if (oFiles is File) {
				if (nMode == 1) print('Sync file ${oFiles.path}');
				// ファイル情報の取得
				String sFullpath = oFiles.path;
		  	String sDir = sFullpath.substring(0, sFullpath.lastIndexOf('\\'));
      	String sFile = sFullpath.substring(sFullpath.lastIndexOf('\\') + 1);
      	String sExt = sFile.substring(sFile.lastIndexOf('.') + 1);
      	// 拡張子フィルター
      	bool bDo = false;
      	if (sTargetExt != null) {
      		if (sTargetExt.indexOf(sExt) != -1) {
      			bDo = true;
      		}
      	} else {
      		// 拡張子の指定がない時は全て対象
      		bDo = true;
      	}
      	if (bDo) {
    	  	sDirectory.add(sDir);
      	  sFileName.add(sFile);
        	sExtension.add(sExt);
  				oTimestamp.add(oFiles.lastModifiedSync());
  				nFilesCount += 1;
    		}
      } else if (oFiles is Directory) {
        nDirsCount += 1;
        if (nMode == 1) print('Sync Dir ${oFiles.path}');
      }
    });
    return nFilesCount;
  }
}
